// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'ionic-datepicker', 'starter.controllers'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

    .state('app', {
      url: "/app",
      abstract: true,
      templateUrl: "templates/social/menu.html",
      controller: 'AppCtrl'
    })

    .state('app.feed', {
      url: "/feed",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/feed.html"
        }
      }
    })

    .state('app.start', {
      url: "/start",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/start-fullscreen.html"
        }
      }
    })

    .state('app.fgrid', {
      url: "/fgrid",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/friend-grid.html",
		  controller: 'InviteCtrl',
        }
      }
    })

    .state('app.flist', {
      url: "/flist",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/friends.html",
		  controller: 'InviteCtrl',
        }
      }
    })

	.state('app.instructor_view', {
      url: "/instructor_view/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/instructor_view.html",
		  controller: 'instructorviewCtrl',
        }
      },
	  params : { id : null }
    })

	
	.state('app.add_comment_instructor', {
      url: "/add_comment_instructor/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/add_comment_instructor.html",
		  controller : 'comment_instr_Ctrl',
        }
      }
    })


    .state('app.forget', {
      url: "/forget",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/forget.html",
		  controller: 'InviteCtrl',
        }
      }
    })

    .state('app.newpost', {
      url: "/newpost",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/new-post.html"
        }
      }
    })

    .state('app.email', {
      url: "/email",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/send-email.html"
        }
      }
    })    

    .state('app.profile', {
      url: "/profile",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/profile.html",
		  controller: 'ProfileCtrl',
        }
      }
    })
	.state('app.editclub', {
      url: "/editclub",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/editclub.html",
		  controller: 'ProfileEditCtrl',
        }
      }
    })

    .state('app.timeline', {
      url: "/timeline",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/timeline.html",
        }
      }
    })

   /* .state('app.editprofile', {
      url: "/editprofile",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/profile-edit.html",
        }
      }
    })*/
	 .state('app.publishjob', {
      url: "/publishjob",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/publishjob.html",
		  controller: 'PublishjobCtrl',
        }
      }
    })
	
	 .state('app.postajob', {
      url: "/postajob",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/postajob.html",
		  controller: 'PublishjobCtrl',
        }
      },
	  params : {id :null}
    })
	
	.state('app.publishajob', {
      url: "/publishajob",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/publishajob.html",
		  controller: 'PublishjobCtrl',
        }
      },
	  params : {id :null,instructorbutton:null}
    })
	
	 .state('app.postvacancy', {
      url: "/postvacancy",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/postvacancy.html",
		  controller: 'PostvacancyCtrl',
        }
      }
    })


    .state('app.profiletwo', {
      url: "/profiletwo",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/profile2.html",
        }
      }
    })

    .state('app.gallery', {
      url: "/gallery",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/gallery.html",
		  controller: 'GalleryCtrl',
        }
      }
    })
	
	 .state('app.reviews', {
      url: "/reviews",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/reviews.html",
		  controller: 'ReviewCtrl',
        }
      }
    })

    .state('app.offer', {
      url: "/offer/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/offer.html",
          controller: 'PublishjobCtrl',
        }
      },
      params : { id : null }
    })
	
	.state('app.favlist', {
      url: "/favlist",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/favorites.html",
		  controller: 'FavCtrl',
        }
      }
    })
	
	 .state('app.search-filter', {
      url: "/search-filter",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/search-filter.html",
        }
      }
    })

    .state('app.news', {
      url: "/news",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/news.html",
        }
      }
    })

    .state('app.viewpost', {
      url: "/viewpost",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/view-post.html",
        }
      }
    })

    .state('app.viewposttwo', {
      url: "/viewposttwo",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/view-post-2.html",
        }
      }
    })
	
	  .state('app.booking', {
      url: "/booking/:jobId",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/booking.html",
		  controller: 'BookingCtrl',
        }
      }
    })
	

    .state('app.mybookings', {
      url: "/mybookings",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/mybookings.html",
		  controller: 'BookingsCtrl',
        }
      }
    })
	
	.state('app.jobs', {
      url: "/jobs",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/jobs.html",
		  controller: 'JobsCtrl',
        }
      }
    })
	
	.state('app.history', {
      url: "/history",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/history.html",
		  controller: 'HistJobsCtrl',
        }
      }
    })

	.state('app.viewjob', {
      url: "/viewjob/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/viewjob.html",
		  controller: 'viewjob',
        }
      },
	  params : { id : null }
    })
	
	 .state('app.editprofile1', {
      url: "/editprofile1",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/editprofile1.html",
		  controller: 'ProfileCtrl',
        }
      }
    })
	 .state('app.editprofile', {
      url: "/editprofile",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/editprofile.html",
		  controller: 'InstEditCtrl',
        }
      }
    })
	
	.state('app.notifications', {
      url: "/notifications",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/notifications.html",
		  controller: 'NotifyCtrl',
        }
      }
    })
	
	.state('app.register', {
      url: "/register",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/register.html",
        }
      }
    })
	
	.state('app.repeating-status', {
      url: "/repeating-status",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/repeating-status.html",
        }
      }
    })
	
	.state('app.update-availablity', {
      url: "/update-availablity",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/update-availablity.html",
        }
      }
    })
	
	.state('app.availability', {
      url: "/availability",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/availability.html",
		  controller: 'DaysCtrl',
        }
      }
    })

    
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/start');
})
.service('sharedProperties', function () {
	var jobId = '';

	return {
		getJobId: function () {
			return jobId;
		},
		setJobId: function(value) {
			jobId = value;
		}
	};
})
.directive('starRating', function () {
    return {
        scope: {
            rating: '=',
            maxRating: '@',
            readOnly: '@',
            click: "&",
            mouseHover: "&",
            mouseLeave: "&"
        },
        restrict: 'EA',
        template:
            "<div style='display: inline-block; margin: 0px; padding: 0px; cursor:pointer;' ng-repeat='idx in maxRatings track by $index'> \
                    <img ng-src='{{((hoverValue + _rating) <= $index) && \"http://www.codeproject.com/script/ratings/images/star-empty-md.png\" || \"http://www.codeproject.com/script/ratings/images/star-fill-md.png\"}}' \
                    ng-Click='isolatedClick($index + 1)' \
                    ng-mouseenter='isolatedMouseHover($index + 1)' \
                    ng-mouseleave='isolatedMouseLeave($index + 1)'></img> \
            </div>",
        compile: function (element, attrs) {
            if (!attrs.maxRating || (Number(attrs.maxRating) <= 0)) {
                attrs.maxRating = '5';
            };
        },
        controller: function ($scope, $element, $attrs) {
            $scope.maxRatings = [];

            for (var i = 1; i <= $scope.maxRating; i++) {
                $scope.maxRatings.push({});
            };

            $scope._rating = $scope.rating;
			
			$scope.isolatedClick = function (param) {
				if ($scope.readOnly == 'true') return;

				$scope.rating = $scope._rating = param;
				$scope.hoverValue = 0;
				$scope.click({
					param: param
				});
			};

			$scope.isolatedMouseHover = function (param) {
				if ($scope.readOnly == 'true') return;

				$scope._rating = 0;
				$scope.hoverValue = param;
				$scope.mouseHover({
					param: param
				});
			};

			$scope.isolatedMouseLeave = function (param) {
				if ($scope.readOnly == 'true') return;

				$scope._rating = $scope.rating;
				$scope.hoverValue = 0;
				$scope.mouseLeave({
					param: param
				});
			};
        }
    };
})
.directive("calendar", function($http) {
	return {
		restrict: "E",
		templateUrl: "templates/social/calendar.html",
		controller: "DaysCtrl",
		scope: {
			selected: "="
		},
		link: function(scope) {			
			scope.selected = _removeTime(scope.selected || moment());
			scope.month = scope.selected.clone();

			var start = scope.selected.clone();
			start.date(1);
			_removeTime(start.day(0));
			_buildMonth(scope, start, scope.month, scope.vacdates);
			$http.get(scope.baseUrl+'api/api.php?action=alljobs').then(function(response){
				scope.vacdates = response.data.jobdate;
				_buildMonth(scope, start, scope.month, scope.vacdates);
			});
			scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
				$http.get(scope.baseUrl+'api/api.php?action=alljobs').then(function(response){
					scope.vacdates = response.data.jobdate;
					_buildMonth(scope, start, scope.month, scope.vacdates);
				});
			});			
			scope.select = function(day) {
			scope.selected = day.date;  
			};
			
			scope.next = function() {
			var next = scope.month.clone();
			_removeTime(next.month(next.month()+1).date(1));
			scope.month.month(scope.month.month()+1);
			_buildMonth(scope, next, scope.month, scope.vacdates);
			};
			
			scope.previous = function() {
			var previous = scope.month.clone();
			_removeTime(previous.month(previous.month()-1).date(1));
			scope.month.month(scope.month.month()-1);
			_buildMonth(scope, previous, scope.month, scope.vacdates);
			};
			
			
		}
	};

	function _removeTime(date) {
		return date.day(0).hour(0).minute(0).second(0).millisecond(0);
	}

	function _buildMonth(scope, start, month, vacdates) {
		scope.weeks = [];
		var done = false, date = start.clone(), monthIndex = date.month(), count = 0;
		while (!done) {
			scope.weeks.push({ days: _buildWeek(date.clone(), month, vacdates) });
			date.add(1, "w");
			done = count++ > 2 && monthIndex !== date.month();
			monthIndex = date.month();
		}
	}

	function _buildWeek(date, month, vacdates) {
		var days = [];
		for (var i = 0; i < 7; i++) {
			var dt = date.year() + '-' + ('0' + (date.month()+1)).slice(-2) + '-' + ('0' + date.date()).slice(-2);
			var avail = vacdates.indexOf(dt);
			var today = new Date();
			days.push({
				name: date.format("dd").substring(0, 1),
				number: date.date(),
				isCurrentMonth: date.month() === month.month(),
				isToday: date.isSame(new Date(), "day"),
				date: date,
				isAvailable:avail>=0?true:false,
				isprevious: date <= today?true:false,
			});
			date = date.clone();
			date.add(1, "d");
		}
		return days;
	}	
})
.config(function($ionicConfigProvider) {
    $ionicConfigProvider.backButton.text('').icon('ion-ios7-arrow-left').previousTitleText(false);
});